unit usort;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons;

type

  { Tfsort }

  Tfsort = class(TForm)
    BitBtn1: TBitBtn;
    bminsort: TButton;
    bbubblesort: TButton;
    bnamensort: TButton;
    Button1: TButton;
    bzufall: TButton;
    b_zufallminsort: TButton;
    b_zufallbubblesort: TButton;
    b_loeschen: TButton;
    ez1: TEdit;
    ez2: TEdit;
    ez3: TEdit;
    ez4: TEdit;
    ez5: TEdit;
    epruef: TEdit;
    etausch: TEdit;
    e_ausgabe: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    lb1: TListBox;
    lb2: TListBox;
    lb3: TListBox;
    Panel1: TPanel;
    procedure bbubblesortClick(Sender: TObject);
    procedure bminsortClick(Sender: TObject);
    procedure bnamensortClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure bzufallClick(Sender: TObject);
    procedure b_zufallbubblesortClick(Sender: TObject);
    procedure b_zufallminsortClick(Sender: TObject);
    procedure b_loeschenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  fsort: Tfsort;
  zufall : ARRAY[1..1000]OF INTEGER;

implementation

{$R *.lfm}

{ Tfsort }

procedure Tfsort.bminsortClick(Sender: TObject);
VAR a : ARRAY[1..5] OF INTEGER;
    i,j,t : INTEGER;
    tauschzahl, pruefzahl : INTEGER;

begin
 //Initialisierung
 tauschzahl:=0;
 pruefzahl:=0;
 //Eingabe
 a[1]:=STRTOINT(ez1.text);
 a[2]:=STRTOINT(ez2.text);
 a[3]:=STRTOINT(ez3.text);
 a[4]:=STRTOINT(ez4.text);
 a[5]:=STRTOINT(ez5.text);
 //Verarbeitung - Sortierung
 FOR i:=1 to 4 DO
  FOR j:=i+1 TO 5 DO
   BEGIN
    pruefzahl:=pruefzahl+1;
    IF a[i]>a[j] THEN
     BEGIN
      t:=a[j];
      a[j]:=a[i];
      a[i]:=t;
      tauschzahl:=tauschzahl+1;
     END;
   END;
 //Ausgabe

 FOR i:=1 TO 5 DO
  e_ausgabe.text:=e_ausgabe.text + INTTOSTR(a[i]) + ';';

 epruef.Text:=INTTOSTR(pruefzahl);
 etausch.Text:=INTTOSTR(tauschzahl);
end;

procedure Tfsort.bnamensortClick(Sender: TObject);
VAR a : ARRAY[1..5] OF STRING[10];
    t : STRING[10];
    i,j : INTEGER;
    tauschzahl, pruefzahl : INTEGER;

begin
 //Initialisierung
 tauschzahl:=0;
 pruefzahl:=0;
 //Eingabe
 a[1]:=ez1.text;
 a[2]:=ez2.text;
 a[3]:=ez3.text;
 a[4]:=ez4.text;
 a[5]:=ez5.text;
 //Verarbeitung - Sortierung
 FOR i:=1 to 4 DO
  FOR j:=i+1 TO 5 DO
   BEGIN
    pruefzahl:=pruefzahl+1;
    IF a[i]>a[j] THEN
     BEGIN
      t:=a[j];
      a[j]:=a[i];
      a[i]:=t;
      tauschzahl:=tauschzahl+1;
     END;
   END;
 //Ausgabe

 FOR i:=1 TO 5 DO
  e_ausgabe.text:=e_ausgabe.text + a[i] + ';';

 epruef.Text:=INTTOSTR(pruefzahl);
 etausch.Text:=INTTOSTR(tauschzahl);
end;

procedure Tfsort.Button1Click(Sender: TObject);
begin
 lb1.Clear;
 lb2.Clear;
 lb3.Clear;
end;

procedure Tfsort.bzufallClick(Sender: TObject);
VAR i : INTEGER;
begin
 FOR i:=1 TO 1000 DO
  BEGIN
   zufall[i]:=RANDOM(1000);
   lb1.Items.Add(INTTOSTR(zufall[i]));
  END;
end;

procedure Tfsort.b_zufallbubblesortClick(Sender: TObject);
VAR zuf : ARRAY[1..1000]OF INTEGER;
    tauschzahl, pruefzahl, i, t, z : INTEGER;
begin
 //Initialisierung
 tauschzahl:=0;
 pruefzahl:=0;
 //Eingabe
 FOR i:=1 TO 1000 DO
  zuf[i]:=zufall[i];
 //Verarbeitung - Sortierung
 REPEAT
  t:=1;
  FOR i:=1 TO 999 DO
   BEGIN
    pruefzahl:=pruefzahl+1;
    IF zuf[i]>zuf[i+1] THEN
     BEGIN
      z:=zuf[i];
      zuf[i]:=zuf[i+1];
      zuf[i+1]:=z;
      t:=0;
      tauschzahl:=tauschzahl+1;
     END;
   END;
 UNTIL t=1;
 //Ausgabe

 FOR i:=1 TO 1000 DO
  lb3.Items.Add(INTTOSTR(zuf[i]));

 epruef.Text:=INTTOSTR(pruefzahl);
 etausch.Text:=INTTOSTR(tauschzahl);
end;

procedure Tfsort.b_zufallminsortClick(Sender: TObject);
VAR zuf : ARRAY[1..1000]OF INTEGER;
    tauschzahl, pruefzahl, i, t, j : INTEGER;

begin
 //Initialisierung
 tauschzahl:=0;
 pruefzahl:=0;
 //Eingabe
 FOR i:=1 TO 1000 DO
  zuf[i]:=zufall[i];
 //Verarbeitung - Sortierung
 FOR i:=1 to 999 DO
  FOR j:=i+1 TO 1000 DO
   BEGIN
    pruefzahl:=pruefzahl+1;
    IF zuf[i]>zuf[j] THEN
     BEGIN
      t:=zuf[j];
      zuf[j]:=zuf[i];
      zuf[i]:=t;
      tauschzahl:=tauschzahl+1;
     END;
   END;
 //Ausgabe

 FOR i:=1 TO 1000 DO
  lb2.Items.Add(INTTOSTR(zuf[i]));

 epruef.Text:=INTTOSTR(pruefzahl);
 etausch.Text:=INTTOSTR(tauschzahl);
end;

procedure Tfsort.b_loeschenClick(Sender: TObject);
begin
  e_ausgabe.Text:='';
end;

procedure Tfsort.FormCreate(Sender: TObject);
begin
  RANDOMIZE;
end;

procedure Tfsort.bbubblesortClick(Sender: TObject);
VAR a : ARRAY[1..5] OF INTEGER;
    i,t,z : INTEGER;
    tauschzahl, pruefzahl : INTEGER;
begin
 //Initialisierung
 tauschzahl:=0;
 pruefzahl:=0;
 //Eingabe
 a[1]:=STRTOINT(ez1.text);
 a[2]:=STRTOINT(ez2.text);
 a[3]:=STRTOINT(ez3.text);
 a[4]:=STRTOINT(ez4.text);
 a[5]:=STRTOINT(ez5.text);
 //Verarbeitung - Sortierung
 REPEAT
  t:=1;
  FOR i:=1 TO 4 DO
   BEGIN
    pruefzahl:=pruefzahl+1;
    IF a[i]>a[i+1] THEN
     BEGIN
      z:=a[i];
      a[i]:=a[i+1];
      a[i+1]:=z;
      t:=0;
      tauschzahl:=tauschzahl+1;
     END;
   END;
 UNTIL t=1;
 //Ausgabe

 FOR i:=1 TO 5 DO
  e_ausgabe.text:=e_ausgabe.text + INTTOSTR(a[i]) + ';';

 epruef.Text:=INTTOSTR(pruefzahl);
 etausch.Text:=INTTOSTR(tauschzahl);
end;

end.

